<?php


function escapeString($stringValue)
{
    global $mysql;

    /*
	if(get_magic_quotes_gpc())
	{
        $stringValue        = stripslashes($stringValue);
    }
    */


	if($mysql->realEscapeString($stringValue))
	{
		$stringValue = $mysql->realEscapeString($stringValue);
	}
	else
		$stringValue = addslashes($stringValue);

	return $stringValue;
}

function get_weekday($number)
{
    global $lang;

    switch ($number) 
    {
        case '1':
            return $lang['weekday_monday'];
            break;
        case '2':
            return $lang['weekday_tuesday'];
            break;
        case '3':
            return $lang['weekday_wednesday'];
            break;  
        case '4':
            return $lang['weekday_thursday'];
            break; 
        case '5':
            return $lang['weekday_friday'];
            break; 
        case '6':
            return $lang['weekday_saturday'];
            break; 
        case '7':
            return $lang['weekday_sunday'];
            break; 
        default:
            return $lang['weekday_unknown'];
            break;
    }

}

function output_lastchange($timestamp, $date_with_time = false)
{
    global $lang;

    $time_difference    = time() - $timestamp;
    $return_lastchange  = "";

    if($time_difference < 60)
    {
        $seconds = $time_difference < 2 ? $lang['lastchange_sec_after_singular'] : $lang['lastchange_sec_after_plural'];

        $return_lastchange          = "{$lang['lastchange_sec_before']} {$time_difference} {$seconds}";
    }
    else if($time_difference < 3600)
    {
        $time_difference_minutes    = round($time_difference / 60);

        $minutes = $time_difference_minutes < 2 ? $lang['lastchange_min_after_singular'] : $lang['lastchange_min_after_plural'];

        $return_lastchange          = "{$lang['lastchange_min_before']} {$time_difference_minutes} {$minutes}";
    }
    else if($time_difference < 86400)
    {
        $time_difference_hours      = round($time_difference / 60 / 60);

        $hours = $time_difference_hours < 2 ? $lang['lastchange_hour_after_singular'] : $lang['lastchange_hour_after_plural'];

        $return_lastchange          = "{$lang['lastchange_hour_before']} {$time_difference_hours} {$hours}";
    }
    else if($time_difference < 259200)
    {
        $time_difference_days      = round($time_difference / 60 / 60 / 24);

        $days = $time_difference_days < 2 ? $lang['lastchange_day_after_singular'] : $lang['lastchange_day_after_plural'];

        $return_lastchange          = "{$lang['lastchange_hour_before']} {$time_difference_days} {$days}";
    }
    else
    {

        $return_lastchange = $date_with_time == true ? date("d.m.Y H:i", $timestamp) : date("d.m.Y", $timestamp);
    }

    return $return_lastchange;
}


function output_archive($page)
{

    global $mysql, $prefix, $lang;

    //-----------------------------------------------------
    //Page Script

    $page               = isset($page) ? $page : 0;
    $limit_entries      = 5;

    $limit_start        = $page * $limit_entries;

    $page_link_newer    = $page - 1;
    $page_link_older    = $page + 1;


    //check für link wie weit man zurückgehen kann

    $limit_start_temp   = ($page + 1) * $limit_entries;

    $query_page_temp    = "SELECT * FROM {$prefix}_archiv WHERE is_test = 0 ORDER BY mailjobTimestamp DESC LIMIT {$limit_start_temp}, {$limit_entries}";

    $get_page_temp      = $mysql->query($query_page_temp);
    if($mysql->numRows($get_page_temp) == 0)
        $show_link_older = false;
    else
        $show_link_older = true;

    //-----------------------------------------------------



    $get_archiv = $mysql->query("SELECT id, betreff, date_format(date, '%d.%m.%Y') as date, mailjobTimestamp 
        FROM {$prefix}_archiv 
        WHERE is_test = 0 
        ORDER BY mailjobTimestamp DESC 
        LIMIT {$limit_start}, {$limit_entries}");

    if($mysql->numRows($get_archiv) > 0)
    {

        echo '<h2 class="archive_headline">'.$lang['start_headline_archive_overview'].'</h2><span class="archive_size_button" id="container_archive_max" title="'.$lang['start_headline_archive_max'].'"><span class="fa fa-arrows-h fa-lg"></span></span>';
        echo "<div class=\"spacer-small\"></div>";

        //Überschriften ausgeben
        echo "<div class=\"first full padding-overall-small background-table-headline text-table-headline\">";

            echo "<div class=\"one-half first\">{$lang['start_headline_archive_subject']}</div>";
            echo "<div class=\"one-third\">{$lang['start_headline_archive_date']}</div>";
            echo "<div class=\"one-twentieth\">&nbsp;</div>";

        echo "</div>";

        echo "<div class=\"spacer-very-small\"></div>";

        echo "<div class=\"first full padding-overall-small\">";


            while($aus_archiv = $mysql->fetchObject($get_archiv))
            {
                $newsletter_subject = empty($aus_archiv->betreff) ? "-" : stripslashes($aus_archiv->betreff);

                echo "
                <div class=\"one-half first\"><a href=\"#\" class=\"archive_show\" data-archiveid=\"{$aus_archiv->id}\">{$newsletter_subject}</a></div>
                <div class=\"one-third\">".output_lastchange(substr($aus_archiv->mailjobTimestamp, 0, -3))."</div>
                <div class=\"float-no-width\"><a href=\"index.php?archive_delete=$aus_archiv->id\" onClick=\"return confirm('".$lang['sendform_sure']."')\" title=\"{$lang['start_archive_delete']}\"><span class=\"fa fa-lg fa-trash-o\"></span></a></div>
                ";
            
                echo "<div class=\"spacer-very-small\"></div>";
            }


            //--------------------------------------------
            //Pages

            output_pagelinks("page-change-archive", "page_loader_archive", $page, $page_link_newer, $page_link_older, $show_link_older);


        echo "</div>";


    }

}



function output_user_stats($page, $id_archiv, $limit_entries)
{

    global $mysql, $prefix, $lang;


    $limit_entries      = isset($limit_entries) ? $limit_entries : 0;
    $page               = isset($page) ? $page : 0;
    $limit_start        = $page * $limit_entries;


    //--------------------------------------

    $html_output  = "";


    $get_archive_user = $mysql->query("SELECT * FROM {$prefix}_archiv_user WHERE id_archiv='{$id_archiv}' ORDER BY user_opened_newsletter_timestamp DESC LIMIT {$limit_start}, {$limit_entries}");
    if($mysql->numRows($get_archive_user) > 0)
    {
        while($out_archive_user = $mysql->fetchObject($get_archive_user))
        {
            $user_opened_newsletter_timestamp = !empty($out_archive_user->user_opened_newsletter_timestamp) ? output_lastchange($out_archive_user->user_opened_newsletter_timestamp, true) : "-";

            $html_output .= "<div class=\"one-half first\">{$out_archive_user->user_email}</div>";
            $html_output .= "<div class=\"one-half\">{$user_opened_newsletter_timestamp}</div>";
        }
    }
    else
    {
            $html_output .= "<div class=\"one-half first\">-</div>";
            $html_output .= "<div class=\"one-half\">-</div>";        
    }





    return $html_output;

}



function output_pagelinks($css_class_js_event, $css_id_js_loader, $page, $page_link_newer, $page_link_older, $show_link_older)
{
    global $lang;

    echo "<div class=\"spacer-small\"></div>";
    

    echo "<div class=\"pagelink-back\">";
    
        if($page > 0)
            echo "<a href=\"#\" class=\"{$css_class_js_event} pagelink\" data-page=\"{$page_link_newer}\" title=\"{$lang['page_back']}\"><span class=\"fa fa-arrow-circle-left fa-2x\"></span></a>";
        else
            echo "&nbsp;";

    echo "</div>";


    echo "<div class=\"pagelink-loader\" id=\"{$css_id_js_loader}\">&nbsp;</div>";


    echo "<div class=\"pagelink-next\">";

        if($show_link_older == true)
            echo "<a href=\"#\" class=\"{$css_class_js_event} pagelink\" data-page=\"{$page_link_older}\" title=\"{$lang['page_next']}\"><span class=\"fa fa-arrow-circle-right fa-2x\"></span></a>";
        else
            echo "&nbsp;";

    echo "</div>";

}



function parse_sql($sql)
{
    $sql        = preg_replace("/\r/s", "\n", $sql);
    $sql        = preg_replace("/[\n]{2,}/s", "\n", $sql);
    $lines      = explode("\n", $sql);
    $queries    = array();
    $in_query   = 0;
    $i          = 0;

    foreach($lines as $line)
    {
        $line=trim($line);

        if(!$in_query)
        {
            if(preg_match("/^CREATE/i", $line))
            {
                $in_query       = 1;
                $queries[$i]    = $line;
            }
            else if(!empty($line) && $line[0] != "#")
            {
                $queries[$i]    = preg_replace("/;$/i", "", $line);
                $i++;
            }
        }
        else if($in_query)
        {
            if(preg_match("/^[\)]/", $line))
            {
                $in_query        = 0;
                $queries[$i]    .= preg_replace("/;$/i", "", $line);
                $i++;
            }
            else if(!empty($line) && $line[0] != "#")
            {
                $queries[$i].=$line;
            }
        }
    }

	return $queries;
}


if(!function_exists('json_encode')) 
{ 
	function json_encode($a=false) 
	{ 
		if (is_null($a)) return 'null'; 
		if ($a === false) return 'false'; 
		if ($a === true) return 'true'; 
		if (is_scalar($a)) 
		{ 
			if (is_float($a)) 
			{ 
				// Always use "." for floats. 
				return floatval(str_replace(",", ".", strval($a))); 
			} 

			if (is_string($a)) 
			{ 
				static $jsonReplaces = array(array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'), array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"')); 
				return '"' . str_replace($jsonReplaces[0], $jsonReplaces[1], $a) . '"'; 
			} 
			else 
				return $a; 
		} 
		$isList = true; 
		for ($i = 0; reset($a); $i)
		{ 
			if (key($a) !== $i) 
			{ 
				$isList = false; 
				break; 
			} 
		} 
		
		$result = array(); 
		if ($isList) 
		{ 
			foreach ($a as $v) $result[] = json_encode($v); 
			return '[' . join(',', $result) . ']'; 
		} 
		else 
		{ 
			foreach ($a as $k => $v) $result[] = json_encode($k).':'.json_encode($v); 
			return '{' . join(',', $result) . '}'; 
		} 
	} 
}




function sendMail($email_recipient, $email_subject, $email_message, $email_sendername, $email_senderemail)
{
    global $mysql, $prefix;

    $isHTML                 = false;


    $get_settings           = $mysql->query("SELECT * FROM {$prefix}_settings");
    $out_settings           = $mysql->fetchObject($get_settings);

    $get_smtp_authtype      = $mysql->query("SELECT * FROM {$prefix}_smtp_authtype WHERE id='{$out_settings->smtp_authtype_id}'");
    $out_smtp_authtype      = $mysql->fetchObject($get_smtp_authtype);

    $get_smtp_encryption    = $mysql->query("SELECT * FROM {$prefix}_smtp_encryption WHERE id='{$out_settings->smtp_encryption_id}'");
    $out_smtp_encryption    = $mysql->fetchObject($get_smtp_encryption);

    $get_charset            = $mysql->query("SELECT * FROM {$prefix}_charset WHERE id='{$out_settings->id_charset}'");
    $out_charset            = $mysql->fetchObject($get_charset);

    //-------------------------------------------------------

    require_once(dirname(__FILE__)."/phpmailer/PHPMailerAutoload.php");
    $mail   = new PHPMailer;

    if($out_settings->send_type == 1)
    {
        $mail->isSMTP();                                                        // Set mailer to use SMTP

        $mail->SMTPKeepAlive  = $out_settings->smtp_keepalive;
        $mail->Host           = $out_settings->smtp_host;                       // Specify main and backup SMTP servers
        $mail->SMTPAuth       = $out_settings->smtp_auth;                       // Enable SMTP authentication
        $mail->AuthType       = $out_smtp_authtype->smtp_authtype;
        $mail->Username       = $out_settings->smtp_user;                       // SMTP username
        $mail->Password       = $out_settings->smtp_password;                   // SMTP password
        $mail->SMTPSecure     = $out_smtp_encryption->smtp_encryption;          // Enable TLS encryption, `ssl` also accepted
        $mail->Port           = $out_settings->smtp_port;                       // TCP port to connect to
    
        if($out_settings->smtp_ignore_ssl_certificate == 1)
        {
            $mail->SMTPOptions = array(
                'ssl' => array(
                    'verify_peer' => false,
                    'verify_peer_name' => false,
                    'allow_self_signed' => true
                )
            );
        }
    }


    $mail->From             = $email_senderemail;
    $mail->FromName         = $email_sendername;
    $mail->Subject          = $email_subject;
    $mail->Body             = $email_message;
    $mail->addAddress($email_recipient);



    $mail->CharSet          = $out_charset->charset;
    $mail->isHTML($isHTML);

    if($mail->send())
        $email_status = true;
    else
        $email_status = false;


    if($out_settings->smtp_keepalive == 1)
        $mail->smtpClose();

    return $email_status;
}




?>