
$(document).ready(function()
{

    if( $("#install_timezone").length > 0 )
	{
	    var tz 			= jstz.determine(); // Determines the time zone of the browser client
	    var timezone 	= tz.name(); 		//'Europe/Berlin' for German Time.

	    
		$("#install_timezone option").each(function()
		{
			if($(this).val() == timezone)
			{
				$(this).attr("selected","selected");
				return false;
			}
		});	
    }

	/* --------------------------------------------------------------------- */
	/* Licence script */

	function licence_validate()
	{
		//execute admin_checksum.php and pass all form variables of admin_licence.php
		$.post("inc/admin_checksum.php", $("#licence_form").serialize(), function(data)
		{
			if(data.checksum == "true")
			{ 
				$("#serialnumber_correct").html("<span class='fa fa-check-circle fa-2x text-green'></span> Valid licence ("+data.test+")");
			}
			else
			{
				$("#serialnumber_correct").html("<span class='fa fa-times-circle fa-2x text-red'></span> No valid licence");
			}
		}, "json");
				
		return false;	
	}
		
	//call function on page load
	if(document.getElementById("licence_form"))
	{
		licence_validate();

		//catch events from key ups from the form fields
		$("#licence_domain").keyup(function()
		{	
			licence_validate();
		});	
		
		$("#licence_serialnumber").keyup(function()
		{	
			licence_validate();
		});	
	}


	/* --------------------------------------------------------------------- */
	/* Bei Abonennten markiere alle Einträge */



	$("#select_all_entries").click(function()
	{
		var form = this.form;

		for (var i = 0; i< form.elements.length; i++) {
			var k = form.elements[i];
			if (k.name != 'all') {
				k.checked = form.all.checked;
			}
		}
	});
	


	/* --------------------------------------------------------------------- */
	/* Misc events */


	$("#change_admin_language").change(function()
	{
		var admin_language 	= $(this).find(":selected").val();
		var current_page 	= $(this).data('current_page');

		window.location.href = "index.php?s="+current_page+"&admin_language="+admin_language;
	});
	


	$("#button_install").click(function()
	{
		$(this).val( $(this).data('value_after_submit') );
	});
	


	$(".add-placeholder").click(function()
	{
		var editor_name = $(this).data('editor_name');
		var content 	= $(this).data('content');

	    document.nletter_form[editor_name].value = document.nletter_form[editor_name].value + content;
	    document.nletter_form[editor_name].focus();


	});
	


	$(".add-placeholder-message").click(function(e)
	{
		var editor_format = $(this).data('editor_format');
		var editor_name = $(this).data('editor_name');
		var editor_type = $(this).data('editor_type');
		var content 	= $(this).data('content');
		var label 		= $(this).data('label');

		if(content.indexOf("_LINK") > -1 && editor_format == "html")
		{
			content = '<a href="'+content+'">'+label+'</a>';
		}

	    embed_to_textarea(editor_type, editor_name, content, false);

	    e.preventDefault();
	});


	$(document).on('click', '.toggle-div', function (e)
	{

		var toggle_id 	= $(this).data('toggle_id');

		$("#"+toggle_id).toggleClass('hide');

		$( $(this) ).toggleClass('open');


		e.preventDefault();
	});


	/*
	$(".toggle-div").click(function(e)
	{

		var toggle_id 	= $(this).data('toggle_id');

		$("#"+toggle_id).toggleClass('hide');

		$( $(this) ).toggleClass('open');


	    e.preventDefault();

	});
	*/


	$(".toggle-div-general").click(function(e)
	{
		var toggle_id 	= $(this).data('toggle_id');

		$("#"+toggle_id).toggleClass('hide');

	    e.preventDefault();

	});
	
	
	
	/* --------------------------------------------------------------------- */
	/* File Browser script */
	
	$("#filebrowser").click(function()
	{
		//call function from divtools.js
		showPart('browser');
		$("#item_browser").html("Loading...");
		
		$.post("inc/admin_filebrowser.php", "",
		function(data)
		{
			$("#item_browser").html(data);
		}, "json");
				
		return false;	
				
    });


	/* --------------------------------------------------------------------- */
	/* Datepicker script */

    $("#datepicker_datesearch").datepicker();


    $(".send_type").click(function()
	{

		if( $('input[name=send_type]:checked').val() == 1)
			$("#smtp_relay_container").removeClass("hide");
		else
			$("#smtp_relay_container").addClass("hide");
	});


	/* --------------------------------------------------------------------- */
	/* SMTP test script */

    $(".smtp_auth").click(function()
	{

		if( $('input[name=smtp_auth]:checked').val() == 1)
			$("#smtp_auth_container").removeClass("hide");
		else
			$("#smtp_auth_container").addClass("hide");
	});


	$("#sendtype_testsettings").click(function()
	{
		$("#output_sendtype_testsettings").html("<img src='images/ajaxloader.gif'>");
  		$.post('inc/admin_query_sendtype_testsettings.php',function(data)
  		{

		    var output = $.parseJSON(data);

		    $("#output_sendtype_testsettings").html(output.sendstatus);

		});
	});


	$(".test_socketwrite").click(function(e)
	{
		$("#output_sendtype_testsettings").html("<img src='images/ajaxloader.gif'>");
		
  		$.post('inc/admin_query_test_socketwrite.php',function(data)
  		{

		    var output = $.parseJSON(data);

		    $("#output_sendtype_testsettings").html(output.sendstatus);

		});

		e.preventDefault();
	});


	/* --------------------------------------------------------------------- */
	/* Chart Pie option */

	$('.chart').easyPieChart(
	{
        lineWidth: 7,
        barColor: '#89BEDE',
        trackColor: '#CCCCCC',
        scaleColor: false,
        size: 110,
        lineCap: 'round',
        animate: { duration: 1000, enabled: true }
    });




	/* --------------------------------------------------------------------- */
	/* Chart Bar option */

	function loadChartBar(labels, data)
	{
		var c1 		= document.getElementById("c1");
		var parent 	= document.getElementById("p1");
		c1.width 	= parent.offsetWidth - 40;
		c1.height 	= parent.offsetHeight - 40;	


		var chartData = {
		  labels : labels,
		  datasets : [
		    {
		      fillColor : "#89BEDE",
		      strokeColor : "rgba(255,255,255,1)",
		      pointColor : "#123",
		      pointStrokeColor : "rgba(255,255,255,1)",
		      data : data
		    }
		  ]
		};

		var chartOptions = {
		  scaleFontColor : "#89BEDE",
		  scaleLineColor : "#89BEDE",
		  scaleGridLineColor : "transparent",
		  bezierCurve : true,
		  animation: true
		};

		new Chart(c1.getContext("2d")).Bar(chartData, chartOptions);		
	}

	function loadChartDoughnut(data)
	{
		var c1 		= document.getElementById("c0");
		var parent 	= document.getElementById("p0");
		c1.width 	= parent.offsetWidth - 40;
		c1.height 	= parent.offsetHeight - 40;	

		var chartData = data;

		var chartOptions = {
		  animationEasing : "easeOutBounce",
		  animateRotate : false,
		  animationSteps : 70,
		  animateScale : true,
		  legendTemplate : "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<%=segments[i].fillColor%>\">&nbsp;</span> <%if(segments[i].label){%><%=segments[i].label%><%}%></li><%}%></ul>"
		};

		var chart = new Chart(c1.getContext("2d")).Doughnut(chartData, chartOptions);
		$('#p0-legend').html( chart.generateLegend() );
	}


	if($('.chart-bar').length > 0)
	{
		var timeRangeDays = 7;

		$('.chart-bar-loader').html("<img src='images/ajaxloader.gif'>");

		$.post("inc/admin_query_get_chartbar_subscriber.php", {timeRangeDays: timeRangeDays}, function(data)
		{


			var output = $.parseJSON(data);

			var chart_label = output.chart_label;
			var chart_data 	= output.chart_data;
			//var chart_label 	= ["Mo.","Di.","Mi.","Do.","Fr.","Sa.","So."];
			//var chart_data 	= [150,100,0,0,410,150,150];


			$('.chart-bar-loader').html("");
			loadChartBar(chart_label, chart_data);
		});
	}

	if($('.chart-doughnut').length > 0)
	{
		$('.chart-doughnut-loader').html("<img src='images/ajaxloader.gif'>");

		
		var count_male 		= $('.chart-doughnut').data('count_male');
		var count_female 	= $('.chart-doughnut').data('count_female');
		var count_unknown 	= $('.chart-doughnut').data('count_unknown');

		var chart_data = [
		    {
		        value: count_male,
		        color:"#89BEDE",
		        highlight: "#6EB4DF",
		        label: "Männlich"
		    },
		    {
		        value: count_female,
		        color: "#E991AA",
		        highlight: "#EA7B9A",
		        label: "Weiblich"
		    },
		    {
		        value: count_unknown,
		        color: "#CCCCCC",
		        highlight: "#BBBBBB",
		        label: "Unbekannt"
		    }
		];


		$('.chart-doughnut-loader').html("");
		loadChartDoughnut(chart_data);
		
	}


	/* --------------------------------------------------------------------- */
	/* Dynamicly load archive */

	function archive_load(archivid)
	{

		$("#output_archive").html("<img src='images/ajaxloader.gif'>");
		//$("#output_archive").load("inc/admin_query_archive_show.php?archivid="+archivid);

		//da dynamisch der iframe befüllt werden muss über diesen weg. normales div wäre nicht gut, da im zweifel gesamtes admin layout zerschossen wird bei html mails
		$.get("inc/admin_query_archive_show.php?archivid="+archivid, function(data)
		{

			//einfache htmle ausgabe mit iframe element, etc. ausgeben
			$("#output_archive").html(data.html_output);


			//Da .chart Klasse beim Ajax Load noch nicht gebunden werden konnte, hier erneut
			$('.chart').easyPieChart(
			{
		        lineWidth: 7,
		        barColor: '#89BEDE',
		        trackColor: '#CCCCCC',
		        scaleColor: false,
		        size: 80,
		        lineCap: 'round',
		        animate: { duration: 1000, enabled: true }
		    });

			//dynamisch geladen weiter oben, wenn existent, dann wiederum json newsletter message in iframe nachladen
		    if($("#archive_newsletter_message").length > 0)
		    {
		    	var newsletter_message = data.newsletter_message;

		    	//$("#iframe_newsletter_message").appendTo("#archive_newsletter_message").contents().find('body').append(newsletter_message);
		    	
		    	//Workaround for Firefox cause iFrame DOM has not yet loaded completly
				var target = $("#iframe_newsletter_message").contents()[0];
				target.open();
				target.close();

		    	$("#iframe_newsletter_message").contents().find('body').append(newsletter_message);
		    }

		}, "json");


		/*
		$("#output_archive").load("inc/admin_query_archive_show.php?archivid="+archivid, function()
		{
			//Da .chart Klasse beim Ajax Load noch nicht gebunden werden konnte, hier erneut
			$('.chart').easyPieChart(
			{
		        lineWidth: 7,
		        barColor: '#89BEDE',
		        trackColor: '#CCCCCC',
		        scaleColor: false,
		        size: 80,
		        lineCap: 'round',
		        animate: { duration: 1000, enabled: true }
		    });

		    if($("#archive_newsletter_message").length > 0)
		    {
		    	var newsletter_message = "test";

		    	$("#iframe_newsletter_message").appendTo("#archive_newsletter_message").contents().find('body').append(newsletter_message);
		    }
		});
		*/


	}


	function load_archive_overview(page)
	{
		$("#output_archive_overview").load("inc/admin_query_archive_overview_show.php?page="+page, function()
		{
		
		});
	}

	$(document).on('click', '.page-change-archive', function (e)
	{
		var page 		= $(this).data('page');
		
		$("#page_loader_archive").html("<img src='images/ajaxloader.gif'>");
		load_archive_overview(page);

		e.preventDefault();
	});


	if($("#output_archive").length > 0)
	{
		archive_load(0);
	}


	$(document).on('click', '.archive_show', function (e)
	{
		e.preventDefault();

		var archiveid = $(this).data('archiveid');
		archive_load(archiveid);

	});




	$(document).on('click', '#button_load_more_subscriber_stats', function (e)
	{
		//var id_savedemails 	= $(this).data('id_savedemails');
		//var confirm_message = $(this).data('confirm_message');


		var page 			= $(this).data("page");
		var pages_total 	= $(this).data("pages_total");
		var id_archiv 		= $(this).data("id_archiv");
		var limit_entries 	= $(this).data("limit_entries");


		page++;
		$(this).data( "page", page );

		//console.log($(this).data("page"));
		//console.log($(this).data("pages_total"));

		if(page >= pages_total)
		{
			$("#button_load_more_subscriber_stats").hide();
		}

		$("#load_more_subscriber_ajaxloader").removeClass("hide");

		$.post("inc/admin_query_user_stats_show.php", {page: page, id_archiv: id_archiv, limit_entries: limit_entries}, function(data)
		{
			//test
			//console.log(data.html_output);
			$(".append_user_stats").append(data.html_output);
			$("#load_more_subscriber_ajaxloader").addClass("hide");


		}, "json");

		e.preventDefault();
	});


	/* --------------------------------------------------------------------- */
	/* Change size of container */

	$("#container_archive_max").click(function()
	{
		if($("#container_stats").is(":visible"))
		{
			$("#container_stats").hide();
			$("#container_archive").removeClass("two-fourth right");
			$("#container_archive").addClass("full first");	
			$("#container_archive").css("box-sizing", "border-box");	
		}
		else
		{
			$("#container_stats").show();
			$("#container_archive").addClass("two-fourth right");
			$("#container_archive").removeClass("full first");
			$("#container_archive").css("box-sizing", "content-box");				
		}

	});


	//------------------------------------------------
	//HTML Template einfügen bzw. URL aufrufen

	$(".template-preview-wrapper").click(function (e)
	{
		e.preventDefault();

		var template_file 	= $(this).data('template_file');
		var confirm_message = $(this).data('confirm_message');

		var editor_name 	= $('#newsletter_message').data('editor_name');
		var editor_type 	= $('#newsletter_message').data('editor_type');


	
		var r = confirm(confirm_message);
		if (r === true)
		{
			$.get("upload/newsletter_templates/"+template_file, function( content )
			{

			    embed_to_textarea(editor_type, editor_name, content, true);
			});

		} 
		
		
	});



	//---------------------------------------------------------------------
	//Popup Code

	//hide popup_background and popup_box
	//$("#popup_background").hide();
	//$("#popup_box").hide();

	//on click show the popup_background div and the message
	$(".popup_show").click(function (e)
	{
		var popup_current = $(this).data('popup');

		$("#popup_background").fadeIn("fast");
		$("#"+popup_current).fadeIn("fast");

		//e.preventDefault();
	});


	//damit es auch nach ajax load gebunden werden kann
	$(document).on('click', '.popup_close', function (e)
	{
		var popup_current = $(this).data('popup');

		$("#popup_background").fadeOut("fast");
		$("#"+popup_current).fadeOut("fast");

		e.preventDefault();
	});

	
	//on click hide the message and the
	$("#popup_background").click(function ()
	{

		$("#popup_background").fadeOut("fast");
		$(".popup_box").fadeOut("fast");
	});


	$(".popup_load_editsubscriber").click(function (e)
	{
		var popup_current 	= $(this).data('popup');
		var id_user 		= $(this).data('id_user');

		$("#"+popup_current).html("<img src='images/ajaxloader.gif'>");
		$("#"+popup_current).load("inc/admin_query_editsubscriber.php?groupedit_id="+id_user);

	});


	$(".popup_load_blacklist").click(function (e)
	{
		var popup_current 	= $(this).data('popup');

		$("#"+popup_current).html("<img src='images/ajaxloader.gif'>");
		$("#"+popup_current).load("inc/admin_query_blacklist.php");

	});



	$(".popup_load_htmlpreview").click(function (e)
	{
		var popup_current 		= $(this).data('popup');
		var newsletter_message 	= $("#newsletter_message").val();

		//console.log(newsletter_message);

		$("#"+popup_current).html("<img src='images/ajaxloader.gif'>");

		if(newsletter_message !== '')
		{
			var frame = $('<iframe>', { class: 'html-preview-frame' });

			$("#"+popup_current).html( $(frame).appendTo("#"+popup_current).contents().find('body').append(newsletter_message) );
		}
		else
		{
			$("#"+popup_current).html('Bisher kein Inhalt geschrieben');
		}
		//$("#"+popup_current).load("inc/admin_query_editsubscriber.php?groupedit_id="+id_user);

	});




	//---------------------------------------------------------------------
	//Save E-Mail

	function load_saveemails_get(page)
	{
		$("#output_saveemails_get").load("inc/admin_query_saveemail_get.php?page="+page);
	}


	$(document).on('click', '.page-change-drafts', function (e)
	{
		var page 		= $(this).data('page');
		
		$("#page_loader_drafts").html("<img src='images/ajaxloader.gif'>");
		load_saveemails_get(page);

		e.preventDefault();
	});


	if($("#output_saveemails_get").length > 0)
	{
		$("#output_saveemails_get").html("<img src='images/ajaxloader.gif'>");
		load_saveemails_get(0);
	}


	$("#button_saveemail").click(function (e)
	{
		//damit aktuelle dinge direkt über post abgegriffen werden
		if(typeof CKEDITOR != 'undefined')
		{
			for (var instance in CKEDITOR.instances )
			        CKEDITOR.instances[instance].updateElement();
			                $('#newsletter_message').trigger('keyup');
		}

		$("#output_saveemails_add").html("<img src='images/ajaxloader.gif'>");

		$.post("inc/admin_query_saveemail_add.php", $("#form_newsletter").serialize(), function(data)
		{
			var output = '';

			if(data.success)
			{
				$.each( data.success, function( key, value )
				{
				  output += '<div class="text-green">'+value+'</div>';

				});				
			}

			if(data.error)
			{
				$.each( data.error, function( key, value )
				{
				  output += '<div class="text-red">'+value+'</div>';

				});
			}

			$("#output_saveemails_add").html(output);
			load_saveemails_get(0);
		

		}, "json");


	});


	$(document).on('click', '.saveemail-delete', function (e)
	{
		var id_savedemails 	= $(this).data('id_savedemails');
		var confirm_message = $(this).data('confirm_message');


		var r = confirm(confirm_message);
		if (r === true)
		{

			$.post("inc/admin_query_saveemail_delete.php", {id_savedemails: id_savedemails}, function(data)
			{
				load_saveemails_get(0);

			}, "json");

		}


		e.preventDefault();
	});


	$(document).on('click', '.saveemail-crud', function (e)
	{
		var id_savedemails 	= $(this).data('id_savedemails');
		var mode 			= $(this).data('mode');

		//damit aktuelle dinge direkt über post abgegriffen werden
		if(typeof CKEDITOR != 'undefined')
		{
			for (var instance in CKEDITOR.instances )
			        CKEDITOR.instances[instance].updateElement();
			                $('#newsletter_message').trigger('keyup');
		}

		$("#output_saveemails_add").html("<img src='images/ajaxloader.gif'>");
		$.post("inc/admin_query_saveemail_crud.php", {mode: mode, id_savedemails: id_savedemails, form: $("#form_newsletter").serialize()}, function(data)
		{
			var output = '';

			if(data.success)
			{
				$.each( data.success, function( key, value )
				{
				  output += '<div class="text-green">'+value+'</div>';

				});				
			}

			if(data.error)
			{
				$.each( data.error, function( key, value )
				{
				  output += '<div class="text-red">'+value+'</div>';

				});
			}

			$("#output_saveemails_add").html(output);

			load_saveemails_get(0);

		}, "json");

		e.preventDefault();
	});


	//---------------------------------------------------------------------
	//Upload Attachment

	var files;

	$('#newsletter_mediaupload_file').on('change', upload_prepare_input);
	$('#newsletter_mediaupload_button').on('click', upload_files);

	function upload_prepare_input(event)
	{
		files = event.target.files;


		//set progressbar to 0
		$('#newsletter_mediaupload_progress').attr({value:0});


	  	output_added_files(files);

	  	//console.log("upload_prepare_input: "+files);
	}


	//-------------------------------------------

	var files_drop;

	files_drop = document.getElementById("newsletter_mediaupload_file_drop");
	if(files_drop !== null)
	{
		files_drop.addEventListener("dragenter", upload_dragenter, false);
		files_drop.addEventListener("dragover", upload_dragover, false);
		files_drop.addEventListener("drop", upload_prepare_drop, false);
	}

	function upload_dragenter(event)
	{
		event.stopPropagation();
		event.preventDefault();

		//$("#newsletter_mediaupload_file_drop").css('cursor', 'pointer');
	}

	function upload_dragover(event)
	{
		event.stopPropagation();
		event.preventDefault();

		//$("#newsletter_mediaupload_file_drop").css('cursor', 'pointer');
	}

	function upload_prepare_drop(event)
	{
		event.stopPropagation();
		event.preventDefault();

		var transfer 	= event.dataTransfer;
		files 			= transfer.files;

		//set progressbar to 0
		$('#newsletter_mediaupload_progress').attr({value:0});

		output_added_files(files);

		//console.log("upload_prepare_drop: "+files);
	}

	//-------------------------------------------

	function output_added_files(files)
	{

		var output = "";

		$.each(files, function(key, value)
		{
			output += "<div>"+value.name+"</div>";
		});


		$("#newsletter_mediaupload_output").html(output);
	}


	function upload_progress(event)
	{
		if(event.lengthComputable)
		{
			$('#newsletter_mediaupload_progress').attr({value:event.loaded, max:event.total});
		}
	}

	function upload_handler_complete(data, textStatus, jqXHR)
    {
        //console.log(data);
        //console.log(textStatus);
        //console.log(jqXHR);

        if(data.status === true)
        {
        	$("#newsletter_mediaupload_output").html("<div class='text-green'>"+$("#newsletter_mediaupload_output").data('output_success')+"</div>");
        }
        else
        {
        	var output_errors = "";

        	for(var i=0; i < data.error.length; i++)
        	{
        		output_errors = data.error[i]+"<br>";

        	}

        	$("#newsletter_mediaupload_output").html("<div class='text-red'>"+output_errors+"</div>");
        }


        load_filebrowser(0);
    }

	function upload_handler_error(jqXHR, textStatus, errorThrown)
	{
		// Handle errors here
		//console.log('Error1: ' + textStatus);
		//console.log('Error2: ' + jqXHR);

		$("#newsletter_mediaupload_output").html("<div class='text-red'>Error: "+textStatus+"</div>");

		// STOP LOADING SPINNER
	}

	function upload_files(event)
	{
		if(files !== undefined)
		{
			event.stopPropagation(); 
			event.preventDefault();

			var formData = new FormData();

			$.each(files, function(key, value)
			{
				formData.append(key, value);
			});


			$.ajax({
				url: 'inc/admin_query_attachment_upload.php',  //Server script to process data
				type: 'POST',

				xhr: function()
				{  // Custom XMLHttpRequest
					var myXhr = $.ajaxSettings.xhr();

					if(myXhr.upload) // Check if upload property exists
					{ 	
						myXhr.upload.addEventListener('progress', upload_progress, false); // For handling the progress of the upload
					}

					return myXhr;
				},

				//Ajax events
				//beforeSend: beforeSendHandler,
				success: upload_handler_complete,
				error: upload_handler_error,

				// Form data
				data: formData,
				dataType: 'json',

				//Options to tell jQuery not to process data or worry about content-type.
				cache: false,
				contentType: false,
				processData: false
			});
		}
	}


	//---------------------------------------------------------------------
	//Load Filebrowser for Newsletter


	function load_filebrowser(page)
	{
		
		$("#newsletter_mediafilebrowser_output").load("inc/admin_query_mediafilebrowser.php?page="+page, function()
		{
			//noch nichts...			
		});

	}

	$(document).on('click', '.page-change-filebrowser', function (e)
	{
		var page 		= $(this).data('page');
		
		$("#page_loader_filebrowser").html("<img src='images/ajaxloader.gif'>");
		load_filebrowser(page);

		e.preventDefault();
	});


	if($("#newsletter_mediafilebrowser_output").length > 0)
	{
		$("#newsletter_mediafilebrowser_output").html("<img src='images/ajaxloader.gif'>");
		load_filebrowser(0);
	}


	//---------------------------------------------------------------------
	//Upload löschen

	$(document).on('click', '.upload-delete', function (e)
	{
		var id_upload 		= $(this).data('id_upload');
		var confirm_message = $(this).data('confirm_message');


		var r = confirm(confirm_message);
		if (r === true)
		{

			$.post("inc/admin_query_upload_delete.php", {id_upload: id_upload}, function(data)
			{
				load_filebrowser(0);

			}, "json");

		}


		e.preventDefault();
	});





	//-----------------------------------------------------------------
	//Funktionen Anhänge dem Newsletter hinzuzufügen oder zu entfernen bzw. einzublenden

	$(document).on('click', '#upload_add_to_attachment', function (e)
	{

		var attachments_new_array = [];

		$('input[name=upload_checkbox]:checked').each(function ()
		{

		    //attachments += $(this).data('filename') + '|';
		    attachments_new_array.push($(this).data('filename'));
		    $(this).attr('checked', false);

		});


		if(attachments_new_array.length > 0)
		{

			
			var input_old 		= $('#newsletter_attachments').val();
			var input_old_array = input_old.split(";");

			
			$.each(input_old_array, function(key, filename_old)
			{
				if(filename_old !== "" && attachments_new_array.indexOf(filename_old) > -1)
				{
					//console.log(filename_old + " bereits vorhanden");

					//aus neuen array entfernen
					//TODO FEHLER nachdenken ;)
					attachments_new_array.splice( attachments_new_array.indexOf(filename_old), 1 );
				}
			});
			


			var attachments_new = "";

			$.each(attachments_new_array, function(key, filename_new)
			{
				attachments_new += filename_new + ";";
			});


			var input_new = input_old + attachments_new;
			$('#newsletter_attachments').val(input_new);

			//Alten Input nehmen und letztes | vom neuen abschneiden
			//console.log(input_old);
			//console.log(attachments_new.substr(0, attachments_new.length -1));

			var output_new = $('#newsletter_attachments').val();

			output_attachments_to_div(output_new);
			
		}



	});

	function output_attachments_to_div(output_new)
	{
		var label = $('#newsletter_attachments_output').data('label');
		var label_delete = $('#newsletter_attachments_output').data('label_delete');

		output_new = "<div class=\"spacer-small\"></div>" + 
		"<div class='info-box background-grey text-bright'>"+
			"<div class='four-fifth first'>"+label+": " + output_new.substr(0, output_new.length -1) + "</div>"+
			"<div style='float: right'><a href=\"#\" class=\"link_invert attachments-delete\" title=\""+label_delete+"\"><span class='fa fa-trash-o'></span></a></div>"+
			"<div class=\"clear\"></div>"+
		"</div>";

		//Zur Optik Space dazwischen
		output_new = output_new.replace(new RegExp('\\;', 'g'), " | ");
		//console.log(output_new);

		//Zur Ausgabe schicken
		$('#newsletter_attachments_output').fadeIn('slow');
		$('#newsletter_attachments_output').html(output_new);
	}

	//damit aus entwurf direkt auch die ausgabe erzeugt wird
	if($('#newsletter_attachments').length > 0 && $('#newsletter_attachments').val() !== "")
	{
		var output_new = $('#newsletter_attachments').val();

		output_attachments_to_div(output_new);		
	}
	


	//---------------------------------------------------------------------
	//Anhang löschen

	$(document).on('click', '.attachments-delete', function (e)
	{
		$('#newsletter_attachments').val('');
		$('#newsletter_attachments_output').fadeOut('slow', function()
		{
			$('#newsletter_attachments_output').html('');
		});

		e.preventDefault();
	});




	//-----------------------------------------------------------------
	//Funktionen Inhalte in die Nachricht einzufügen

	$(document).on('click', '#upload_embed_to_message', function (e)
	{

		var embed_objects 	= {};
		var editor_name 	= $('#newsletter_message').data('editor_name');
		var editor_type 	= $('#newsletter_message').data('editor_type');


		$('input[name=upload_checkbox]:checked').each(function ()
		{

		    embed_objects[$(this).data('filename')] = $(this).data('fileurl');


		    $(this).attr('checked', false);

		});

		var content;
		
		$.each(embed_objects, function(file, url)
		{

			if(file_is_image(file) === true)
			{
				content = '<img src="'+url+file+'">';
			}
			else
			{
				content = '<a href="'+url+file+'">'+url+file+'</a>';
			}

			

			embed_to_textarea(editor_type, editor_name, content, false);
			

		});
		
		

		e.preventDefault();
	});

	function file_is_image(file)
	{
		file = file.toLowerCase();

		image_extensions = ['.jpg', '.jpeg', '.gif', '.png', '.tif', '.bmp'];

		for(var i=0; i<image_extensions.length; i++)
		{
			if(file.indexOf(image_extensions[i]) > -1)
			{
				return true;
			}			
		}

		return false;

	}


	function embed_to_textarea(editor_type, editor_name, content, overwrite)
	{
					

		if(editor_type == "wysiwyg")
		{
			if(overwrite === false)
				CKEDITOR.instances[editor_name].insertHtml(content);
			else
				CKEDITOR.instances[editor_name].setData(content);
		}
		else
		{
			if(overwrite === false)
				$('#newsletter_message').val( $('#newsletter_message').val() + content );
			else
			{
				$('#newsletter_message').val( content );
			}
		}

	}

});
