<?php

class databaseConnector
{
	// -----------------------------------------------------------------
	// Attributes
	private $db_type;
	private $db_connection;
	private $db_debug_error;
	

	// -----------------------------------------------------------------
	// Contructor

	public function __construct($db_type, $db_host, $db_user, $db_password, $db_name)
	{	
		$this->db_type 			= $db_type;
		$this->db_debug_error 	= false;
		
		if($this->db_type == "mysqli")
		{
			$this->db_connection = @mysqli_connect($db_host, $db_user, $db_password, $db_name);

			if(!$this->db_connection)
				return false;

		}
		
	}
	
	
	// -----------------------------------------------------------------
	// Methods
	
	public function getDb_connection()
	{
		return $this->db_connection;
	}
	
	public function query($sql)
	{
		if(!$this->db_connection)
		{
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			/*
			try
			{
				$query_result = mysqli_query($this->db_connection, $sql);


				if (!$query_result)
				{
					throw new Exception(mysqli_error($this->db_connection));
   		 		}

				return $query_result;
			}
			catch (Exception $e)
			{
				echo $e->getMessage();
			}
			*/

			$query_result = mysqli_query($this->db_connection, $sql);
			
			if($query_result)
			{
				return $query_result;
			}
			else
			{
				$this->errorHandlingSQL();

				return false;
			}
			
		}		
	}

	public function realEscapeString($string)
	{
		if(!$this->db_connection)
		{
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_real_escape_string($this->db_connection, $string);
		}	
	}

	public function setDebugError($value)
	{
		if(!$this->db_connection)
		{
			return false;
		}
		
		$this->db_debug_error = $value;
	}

	public function setCharset($string)
	{
		if(!$this->db_connection)
		{
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_set_charset($this->db_connection, $string);
		}	
	}
	
	public function fetchObject($sqlId)
	{
		if(!$this->db_connection || !$sqlId)
		{

			//$this->errorHandlingSQL();
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_fetch_object($sqlId);
		}		
	}

	public function freeResult($sqlId)
	{
		if(!$this->db_connection || !$sqlId)
		{

			//$this->errorHandlingSQL();
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_free_result($sqlId);
		}		
	}

	public function fetchRow($sqlId)
	{
		if(!$this->db_connection || !$sqlId)
		{

			//$this->errorHandlingSQL();
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_fetch_row($sqlId);
		}		
	}
	
	public function fetchArray($sqlId)
	{
		if(!$this->db_connection || !$sqlId)
		{

			//$this->errorHandlingSQL();
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_fetch_array($sqlId);
		}		
	}

	public function numRows($sqlId)
	{
		if(!$this->db_connection)
		{
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_num_rows($sqlId);
		}		
	}
	
	public function insertId()
	{
		if(!$this->db_connection)
		{
			return false;
		}
		
		if($this->db_type == "mysqli")
		{
			return mysqli_insert_id($this->db_connection);
		}		
	}


	public function errorHandlingSQL()
	{

		//if($this->db_debug_error == false)
			//die($debug_output);

		if($this->db_debug_error == true)
		{

			$debug_backtrace 	= debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
			$debug_output 		= "";


			for($i=0; $i<count($debug_backtrace); $i++)
			{
				$debug_output .= "<br><b>SQL Error in File:</b> ".$debug_backtrace[$i]['file']." on Line ".$debug_backtrace[$i]['line'];
				
			}
			//var_dump($debug_backtrace);
			if(!empty($debug_output))
				echo $debug_output;

			//won't show up when die() is used
			if(isset($this->db_connection) && !empty($this->db_connection))
				echo "<br><b>SQL Error ".mysqli_errno($this->db_connection)."</b>: ".mysqli_error($this->db_connection)."<br>";
		}
	}



}

?>